#include "chdecl.h"
void CH_tokenstrings(current, sched, cop)
#define ARGUMENTS 8
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb2;
    case 2: goto c3;
    case 3: goto c6;
    case 4: goto c44;
    case 5: goto c47;
    case 6: goto c50;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
/* block , 1 */
  if((ch_returncode = che_block(QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb2:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c3:
/* new_table 3.1 , 2 */
  if ((ch_returncode = che_new_table(DEF(3)DOT(1),QUAL(2),sched)) != Normal) 
     goto ch_raise_exception;
/* copy 4 3.0 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(0).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(4).tsdr)->finalize)(REF(4).value,F_DISCARD,sched);
  REF(4).value = ch_val;
  REF(4).tsdr = & dr_table;
/* initget 5 4 , 0,0 */
  (*(REF(5).tsdr)->finalize)(REF(5).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(5),DEF(4),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c6:
/* get_or_goto 5 4 , 39 */
  if ((ch_returncode = get_selected_object(DEF(5),DEF(4),sched)) != Normal)
     goto c39;
/* case 6 5 */
  REF(6).value.enumeration = REF(5).value.variant->info.variant_case;
  REF(6).tsdr = & dr_enumeration;
/* equal . 6 =(3) , 18 */
  if ( REF(6).value.enumeration == 3 ) goto c18;
/* equal . 6 =(2) , 22 */
  if ( REF(6).value.enumeration == 2 ) goto c22;
/* equal . 6 =(1) , 26 */
  if ( REF(6).value.enumeration == 1 ) goto c26;
/* equal . 6 =(0) , 32 */
  if ( REF(6).value.enumeration == 0 ) goto c32;
/* branch , 36 */
   goto c36;
c18:
/* reveal 5 , 3 */
  if (3 != REF(5).value.variant->info.variant_case) goto ch_case_error;
/* copy 7 5.0.2 */
  if((ch_returncode = (REF(5)DOT(0)DOT(2).tsdr->copy)(& ch_val, 
    REF(5)DOT(0)DOT(2).value)) != Normal) goto ch_raise_exception;
  (*(REF(7).tsdr)->finalize)(REF(7).value,F_DISCARD,sched);
  REF(7).value = ch_val;
  REF(7).tsdr = datarepmap[REF(5)DOT(0)DOT(2).tsdr->number];
/* insert 3.1 7 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(1),DEF(7),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 6 */
   goto c6;
c22:
/* reveal 5 , 2 */
  if (2 != REF(5).value.variant->info.variant_case) goto ch_case_error;
/* copy 8 5.0.1 */
  if((ch_returncode = (REF(5)DOT(0)DOT(1).tsdr->copy)(& ch_val, 
    REF(5)DOT(0)DOT(1).value)) != Normal) goto ch_raise_exception;
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  REF(8).value = ch_val;
  REF(8).tsdr = datarepmap[REF(5)DOT(0)DOT(1).tsdr->number];
/* insert 3.1 8 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(1),DEF(8),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 6 */
   goto c6;
c26:
/* reveal 5 , 1 */
  if (1 != REF(5).value.variant->info.variant_case) goto ch_case_error;
/* new_table 9 , 3 */
  if ((ch_returncode = che_new_table(DEF(9),QUAL(3),sched)) != Normal) 
     goto ch_raise_exception;
/* copy 10 5.0 */
  if((ch_returncode = (REF(5)DOT(0).tsdr->copy)(& ch_val, REF(5)DOT(0).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(10).tsdr)->finalize)(REF(10).value,F_DISCARD,sched);
  REF(10).value = ch_val;
  REF(10).tsdr = datarepmap[REF(5)DOT(0).tsdr->number];
/* insert 9 10 */
  if ((ch_returncode = insertfunc(DEF(9),DEF(10),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* insert 3.1 9 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(1),DEF(9),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 6 */
   goto c6;
c32:
/* reveal 5 , 0 */
  if (0 != REF(5).value.variant->info.variant_case) goto ch_case_error;
/* copy 11 5.0 */
  if((ch_returncode = (REF(5)DOT(0).tsdr->copy)(& ch_val, REF(5)DOT(0).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(11).tsdr)->finalize)(REF(11).value,F_DISCARD,sched);
  REF(11).value = ch_val;
  REF(11).tsdr = datarepmap[REF(5)DOT(0).tsdr->number];
/* insert 3.1 11 */
  if ((ch_returncode = insertfunc(DEF(3)DOT(1),DEF(11),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 6 */
   goto c6;
c36:
/* exit , 4 */
  ch_e = handler_type__exit; ch_val = QUAL(4); goto ch_exception;
c39:
/* endget 5 4 */
  end_selector(DEF(5),DEF(4),sched,GET);
/* discard 4 */
  (*(REF(4).tsdr)->finalize)(REF(4).value,F_DISCARD,sched);
  REF(4).tsdr = & dr_bottom;
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
/* branch , 47 */
   goto c47;
c44:
/* chs_lit 12 , "CantHappen happened in tokenStrings" */
  if( !chs_lit(DEF(12),"CantHappen happened in tokenStrings") )
     goto ch_depletion;
/* print 12 */
  re_print(stderr, 0, DEF(12)); fflush(stderr);
/* discard 12 */
  (*(REF(12).tsdr)->finalize)(REF(12).value,F_DISCARD,sched);
  REF(12).tsdr = & dr_bottom;
c47:
/* discard 3 */
  (*(REF(3).tsdr)->finalize)(REF(3).value,F_DISCARD,sched);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c50:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
